#include <ESP8266WiFi.h>
#include <WiFiUDP.h>
#include <ESP8266WebServer.h>
#include <Ticker.h>


WiFiUDP Udp;
const char* ssid = "SSID";
const char* password = "PASSWORD";

IPAddress broadcastaddress(224, 0, 0, 1);
unsigned int broadcastport = 4096;
unsigned int udpport = 4096;
IPAddress localIPaddress;
IPAddress controlIPaddress;
char controladdressaschar[20];
char localaddressaschar[20];
boolean iscontroller = 0;
boolean sync = 1;
boolean operating = 1;

boolean debug = 1;
boolean lightdatadebug = 0;
boolean protocoldebug = 1;

char packetBuffer[255]; //buffer to hold incoming packet
int packetSize;
char result[16];
char sendbuffer[64];
char numasstring[16];

char resyncbuffer[5];
//char controlbuffer[20];
char modebuffer[5];
char intervalbuffer[10];

Ticker lightcontrol;
Ticker nodesync;
Ticker checksync;
  
int syncinterval = 5000;      //all ms
int controlinterval = 20000;

int forwardpwmPIN = 14;           // comes out D5, forward pwm pin
int forwardenablePIN = 12;        // comes out D6, forward enable
int reversepwmPIN = 13;           // comes out D7, reverse pwm pin
int reverseenablePIN = 15;       // comes out D8, reverse enable

int lightmode = 0;

byte lightoffset = 0;
boolean heardsync = 1;

ESP8266WebServer server ( 80 );
char htmlResponse[300];
char htmlpage[3500];
  
void setup()
  {
  // initialize digital pin LED_BUILTIN as an output for testing.
  pinMode(LED_BUILTIN, OUTPUT); 
  analogWriteFreq(4000);
  analogWriteRange(1023);
  pinMode(forwardpwmPIN, OUTPUT);
  pinMode(reversepwmPIN, OUTPUT);
  pinMode(forwardenablePIN, OUTPUT);
  pinMode(reverseenablePIN, OUTPUT);

  stoplights();         // set light outputs to off state
  setlighttimer();      //start just the lights until the wifi connects
  Serial.begin(115200); //Start communication to monitor window
  delay(2000);
  
  connect_wifi();
  Udp.begin(udpport);
  startServer();
  starttimers();
  }

void loop()
  {
  if (sync == 1)
    listen();
  handleClient();
  }
